#include <iostream>
#include <string>

using namespace std;

const int ONES_LIMIT = 19;
const int TENS_LIMIT = 99;
const int HUNDREDS_LIMIT = 999;
const int MAX_NUM = 999999;
const int MIN_NUM = -999999;


string ones[] = {"zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"};
string tens[] = {"zero", "ten", "twenty", "thirty", "fourty", "fifty", "sixty", "seventy", "eighty", "ninety"};

// ! Prototypes
string ones_to_words(int number);
string tens_to_words(int number);
string hundreds_to_words(int number);
string thousands_to_words(int number);
string number_to_words(int number);

int main()
{
	int number;
	string number_string;

	cout << "Enter a number between " << MIN_NUM << " and " << MAX_NUM << " :";
	cin >> number;

	if (number < MIN_NUM)
	{
		cout << "That number is too small." << endl;
		return 0;
	}
	else if (number > MAX_NUM)
	{
		cout << "That number is too big." << endl;
		return 0;
	}

	number_string = number_to_words(number);

	cout << number << " is pronounced as: " << number_string << endl;
}

string number_to_words(int number)
{
	string output = "";

	// Take care of the negative sign first thing
	if (number < 0)
	{
		number *= -1;
		output += "negative ";
	}

	if (number == 0)
	{
		output += ones[0];
	}
	else if (number > HUNDREDS_LIMIT)
	{
		output += thousands_to_words(number);
	}
	else if (number > TENS_LIMIT)
	{
		output += hundreds_to_words(number);
	}
	else if (number > ONES_LIMIT)
	{
		output += tens_to_words(number);
	}
	else if (number < ONES_LIMIT)
	{
		output += ones_to_words(number);
	}

	return output;
}

string thousands_to_words(int number)
{
	int num_thousands = number / 1000;
	int rem_hundreds = number % 1000;

	string separator = (rem_hundreds > 1) ? ", " : " ";

	return hundreds_to_words(num_thousands) + " thousand" + separator + hundreds_to_words(rem_hundreds);
}

string hundreds_to_words(int number)
{
	// Delegate to next function
	if (number < TENS_LIMIT)
	{
		return tens_to_words(number);
	}

	int num_hundreds = number / 100;
	int rem_tens = number % 100;

	string hundred_string = ones_to_words(num_hundreds) + " hundred";

	if (rem_tens > 0)
	{
		hundred_string += " " + tens_to_words(rem_tens);
	}

	return hundred_string;
}

string tens_to_words(int number)
{
	// Delegate to next function
	if (number < ONES_LIMIT)
	{
		return ones_to_words(number);
	}

	int num_tens = number / 10;
	int rem_ones = number % 10;

	string one_string = ones_to_words(rem_ones);
	string seperator = (rem_ones > 0) ? "-" : " ";

	return tens[num_tens] + seperator + ones_to_words(rem_ones);
}

string ones_to_words(int number)
{
	if (number == 0)
	{
		return "";
	}

	return (number == 0) ? "" : ones[number];
}
